import { Common } from './aws-cognito.common';
import { CognitoCommonDelegate } from "./CognitoCommonDelegate";
import { CognitoIdentityInteractiveAuthenticationDelegate } from "./CognitoIdentityInteractiveAuthenticationDelegate";
import { AWSCognitoIdentityPasswordAuthenticationImpl } from "./ios/AWSCognitoIdentityPasswordAuthenticationImpl";
export declare let invokeOnRunLoop: (func: any) => void;
export declare class AwsCognito extends Common {
    static awsServiceConfiguration: AWSServiceConfiguration;
    static awsCognitoIdentityUserPoolConfiguration: AWSCognitoIdentityUserPoolConfiguration;
    static awsCognitoIdentityUserPool: AWSCognitoIdentityUserPool;
    static awsCognitoIdentityPasswordAuthenticationImpl: AWSCognitoIdentityPasswordAuthenticationImpl;
    static createUserPool(region: string, cliendId: string, secretId: string, poolId: string, delegate: CognitoIdentityInteractiveAuthenticationDelegate): void;
    static registerUser(userName: String, password: String, attrubutes: Array<{
        key: string;
        value: string;
    }>, delegate: CognitoCommonDelegate): void;
    static confirmSignUp(userName: String, verifyCode: String, delegate: CognitoCommonDelegate): void;
    static getUserDetail(delegate: CognitoCommonDelegate): void;
    static login(userName: String, password: String, delegate: CognitoCommonDelegate): void;
    static signOut(): void;
}
