"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var invokeOnRunLoop = (function () {
    var runLoop = CFRunLoopGetMain();
    return function (func) {
        CFRunLoopPerformBlock(runLoop, kCFRunLoopDefaultMode, func);
        CFRunLoopWakeUp(runLoop);
    };
}());
var AWSCognitoIdentityPasswordAuthenticationImpl = (function (_super) {
    __extends(AWSCognitoIdentityPasswordAuthenticationImpl, _super);
    function AWSCognitoIdentityPasswordAuthenticationImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AWSCognitoIdentityPasswordAuthenticationImpl.new = function () {
        return _super.new.call(this);
    };
    AWSCognitoIdentityPasswordAuthenticationImpl.prototype.setCognitoCommonDelegate = function (cognitoCommonDelegate) {
        this.cognitoCommonDelegate = cognitoCommonDelegate;
    };
    AWSCognitoIdentityPasswordAuthenticationImpl.prototype.getPasswordAuthenticationCompletionSource = function () {
        return this.passwordAuthenticationCompletionSource;
    };
    AWSCognitoIdentityPasswordAuthenticationImpl.prototype.getPasswordAuthenticationDetailsPasswordAuthenticationCompletionSource = function (authenticationInput, passwordAuthenticationCompletionSource) {
        this.passwordAuthenticationCompletionSource = passwordAuthenticationCompletionSource;
    };
    AWSCognitoIdentityPasswordAuthenticationImpl.prototype.didCompletePasswordAuthenticationStepWithError = function (error) {
        var _this = this;
        invokeOnRunLoop(function () {
            if (error) {
                _this.cognitoCommonDelegate.onError(error.userInfo.valueForKey("message"));
            }
            else {
                _this.cognitoCommonDelegate.onSuccess(null);
            }
        });
    };
    return AWSCognitoIdentityPasswordAuthenticationImpl;
}(NSObject));
AWSCognitoIdentityPasswordAuthenticationImpl.ObjCProtocols = [AWSCognitoIdentityPasswordAuthentication];
exports.AWSCognitoIdentityPasswordAuthenticationImpl = AWSCognitoIdentityPasswordAuthenticationImpl;
//# sourceMappingURL=AWSCognitoIdentityPasswordAuthenticationImpl.js.map